/*
 * Liste:
 * - identificate dal primo elemento
 * - singolarmente concatenate
 * - ordinate (in modo non decrescente)
 */

class List {
	int value;
	List next;
}


public class MainClass {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		List l = null;
		l=insert(l,10);
		l=insert(l,20);
		l=insert(l,12);
		stampaLista(l);
		System.out.println("lunghezza ="+length(l));
		
		System.out.println (search(l,15));
		System.out.println (search(l,12));
		
		System.out.println (searchRic(l,15));
		System.out.println (searchRic(l,12));
		
		l=delete(l,12);
		stampaLista(l);
		
		System.out.println (search(l,15));
		System.out.println (search(l,12));
		

	}
	
	//metodo che inseresci in lista - ATTENZIONE: la lista  ordinata
	static List insert (List l, int value) {
		List nuovo = new List();
		nuovo.value=value;
		List i = l;
		List prev=null;
		while (i!=null && i.value<value) {
			prev=i;
			i=i.next;
		}
		if (prev==null) {//devo inserire "nuovo" in prima posizione
			nuovo.next=l;
			return nuovo;
		} else {
			prev.next=nuovo;
			nuovo.next=i;
			return l;
		}			
	}
	
	
	
	static void stampaLista (List l) {
		for (List i=l; i!=null; i=i.next) {
			System.out.print(i.value + " ");
		}
		System.out.println();		
	}
	
	
	//metodo ricorsivo
	static void stampaListaRic (List l) {
		if (l==null) {
			System.out.println();
			return;
		}
		System.out.print(l.value + " ");
		stampaListaRic (l.next);		
	}
	
	
	
	//versione iterativa
	static int length (List l) {
		int conto=0;
		for (List i=l; i!=null; i=i.next) {
			conto++;
		}
		return conto;
	}
	
	//versione ricorsiva
	static int lengthRic (List l) {
		if (l==null) return 0;	
		else return 1+lengthRic(l.next);
	}
	
	//ricerca in una lista - versione iterativa
	static boolean search (List l, int valore) {
		for (List i=l;i!=null && i.value<=valore ;i=i.next) {
			if (i.value==valore) return true;
		}
		return false;
	}
	
	//ricerca in una lista - versione ricorsiva
	static boolean searchRic (List l, int valore) {
		if (l==null || l.value>valore) return false;
		if (l.value==valore) return true;
		return searchRic (l.next, valore);
	}
	
	/*
	 * metodo che rimuove la prima occorrenza di "valore"
	 * dalla lista e restituisce la nuova lista ottenuta
	 */
	static List delete (List l, int valore) {
		List i=l;
		List prev=null;
		while (i!=null && i.value<valore) {
			prev=i;
			i=i.next;
		}
		if (i==null || i.value>valore) return l;
		//se arrivo qui, i identifica l'elemento da cancellare (i.value==valore)
		if (prev==null) {//devo cancellare il PRIMO elemento
			return i.next;
		} else {
			prev.next=i.next;
			return l;
		}
		
		
	}
	

}
