class Punto {
	double x;
	double y;
}

class Intero {
	int n;
}


class Elem{
	int value;
	Elem next;
}

class Stack {
	Elem top;
	int size;
}

class Queue{
	Elem first;
	Elem last;
	int size;
}



public class MainClass {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		System.out.println("Inizio");
		//testTipiRiferimento();
		//arrayTipiRiferimento();
		//testPila();
		testCoda();
		System.out.println("Fine");
	}
	
	
	static void testCoda () {
		Queue q = new Queue();
		enqueue(q, 4);
		enqueue(q, 7);
		enqueue(q, 1);
		stampaCoda (q);
		System.out.println ("Estraggo "+dequeue(q) );
		stampaCoda (q);
		System.out.println ("Estraggo "+dequeue(q) );
		stampaCoda (q);
		enqueue(q, 10);
		stampaCoda (q);
		System.out.println ("Estraggo "+dequeue(q) );
		stampaCoda (q);
		System.out.println ("Estraggo "+dequeue(q) );
		stampaCoda (q);
		System.out.println ("Estraggo "+dequeue(q) );
		stampaCoda (q);
	}
	
	static void stampaCoda (Queue q) {
		if (q==null) return;
		for (Elem i=q.first; i!=null; i=i.next) {
			System.out.print(i.value);
			if (i.next!=null) {
				System.out.print("; ");
			}
		}
		System.out.println();
	}
	
	static void enqueue (Queue q, int value) {
		if (q==null) {
			System.out.println("Queue does not exist!");
			return;
		}
		Elem e = new Elem();
		e.value=value;
		//aggiungiamo e come il "last" della coda
		if (q.last != null) {
			(q.last).next=e;
		} else { //la coda era vuota
			q.first=e;
		}
		q.last=e;
		q.size++;	
	}
	
	static int dequeue (Queue q) {
		if (q==null) {
			System.out.println("Queue does not exist!");
			return 0;
		}
		if (q.first==null) {
			System.out.println("Empty queue!");
			return 0;
		}
		int ris = (q.first).value;
		q.first = (q.first).next;
		if (q.first==null) { //ho svuotato la coda
			q.last=null;
		}
		q.size--;
		return ris;
	}
	
	
	static void testPila() {
		Stack s = new Stack();
		push(s, 10);
		push(s, 8);
		push(s, 4);
		stampaPila(s);
		System.out.println ("Estraggo " + pop(s));
		stampaPila(s);
		System.out.println ("Estraggo " + pop(s));
		stampaPila(s);
		System.out.println ("Estraggo " + pop(s));
		stampaPila(s);	
		
	}
	
	static void push (Stack s, int value) {
		if (s==null) {
			System.out.println("Stack does not exist!");
			return;
		}
		//creazione di un oggetto della classe elem con il dato valore
		Elem e = new Elem();
		e.value=value;
		e.next=s.top;
		s.top=e;
		s.size++;
	}
	
	static int pop (Stack s) {
		if (s==null) {
			System.out.println("Stack does not exist!");
			return 0;
		}
		if (s.top==null) {
			System.out.println("Empty stack!");
			return 0;
		}
		int ris = (s.top).value;
		s.top = (s.top).next;
		s.size--;
		return ris;
	}
	
	static void stampaPila (Stack s) {
		if (s==null) return;
		Elem e = s.top;
		while (e!=null) {
			System.out.print (e.value);
			if (e.next!=null) {
				System.out.print ("; ");
			}
			e = e.next;
		}
		System.out.println();
	}
	
	static void stampaPila2 (Stack s) {
		if (s==null) return;
		//Elem e = s.top;
		//while (e!=null) {
		for (Elem e=s.top; e!=null; e=e.next) {
			System.out.print (e.value);
			if (e.next!=null) {
				System.out.print ("; ");
			}
			//e = e.next;
		}
		System.out.println();
	}
	
	/*
	 * scrivere un metodo contoSuBisettrice che,
	 * preso in input un array di Punto,
	 * restituisce il numero di elementi che rappresentano
	 * punti appartenenti alla retta y=x
	 */
	static int contoSuBisettrice (Punto[] a) {
		if (a==null) return 0;
		int conto=0;
		for (int i=0; i< a.length; i++) {
			if (a[i]!=null && a[i].x==a[i].y) {
				conto++;
			}
		}
		return conto;
	}
	
	
	static void arrayTipiRiferimento () {
		int[] a = new int[5];
		for (int i=0; i<a.length; i++) {
			a[i]=i+1;
		}
		for (int i=0; i<a.length; i++) {
			System.out.println(a[i]);
		}
		
		Intero[] b = new Intero[5];
		for (int i=0; i<b.length; i++) {
			b[i] = new Intero();
			b[i].n=i+1;
		}
		for (int i=0; i<b.length; i++) {
			System.out.println(b[i].n);
		}
		
	}
	
	static void testTipiRiferimento () {
		int pippo=5;
		int pluto=pippo;
		System.out.println(pippo);
		System.out.println(pluto);
		pluto = 10;
		System.out.println(pippo);
		System.out.println(pluto);
		
		System.out.println("----");
		
		Intero pippo2 = new Intero();
		pippo2.n=5;
		Intero pluto2 = pippo2;
		System.out.println(pippo2.n);
		System.out.println(pluto2.n);
		pluto2.n = 10;
		System.out.println(pippo2.n);
		System.out.println(pluto2.n);
		
		
		
	}

}
